// utilities:
const isPromise = require('is-promise-for-real');

module.exports = ({ dispatch }) => {
    return (next) => (action) => {
        const promiseIsFound = Boolean(
            Object.values(action)
                .find((element) => isPromise(element))
        );

        if (!promiseIsFound) {
            return next(action);
        }

        resolvePromises(action);

        function resolvePromises(action, beginIndex = 0) {
            let nextBeginIndex;

            const prop = 0, value = 1;
            const promise = Object.entries(action)
                .splice(beginIndex)
                .find((element, elementIndex) => {
                    if (isPromise(element[value])) {
                        elementIndex = elementIndex || 1;
                        nextBeginIndex = beginIndex + elementIndex;
                        return element[value];
                    }
                });

            if (!promise) {
                return dispatch(action);
            }

            promise[value]
                .then((res) => {
                    action = { ...action, [promise[prop]]: res };
                    resolvePromises(action, nextBeginIndex);
                })
                .catch((error) => {
                    action = { ...action, [promise[prop]]: error, error: true };
                    resolvePromises(action, nextBeginIndex);
                });
        };
    };
};
